package com.biganto.visual.roompark.di.dagger

import com.biganto.visual.roompark.base.RoomParkApplication
import com.biganto.visual.roompark.data.repository.api.retrofit.di.RetrofitModule
import com.biganto.visual.roompark.data.repository.db.requrey.DbModule
import dagger.Component
import dagger.android.AndroidInjectionModule
import dagger.android.AndroidInjector
import dagger.android.support.AndroidSupportInjectionModule
import javax.inject.Singleton



/**
 * Created by Vladislav Bogdashkin on 13.06.2018.
 */

@Singleton
@Component(modules =
[   AppModule::class,
    DataModule::class,
    RetrofitModule::class,
    DbModule::class,
//    LocalStorage::class,
//    AppVersionModule::class,
    AndroidInjectionModule::class,
    AndroidSupportInjectionModule::class,
//    MappingProvider::class,
    ActivityModule::class,

    AppActivityModule ::class])
interface AppComponent : AndroidInjector<RoomParkApplication>{

    @Component.Factory
    interface Factory:AndroidInjector.Factory<RoomParkApplication>{

//        @BindsInstance
//        fun context(application: Application): Factory

//        @BindsInstance
//        fun retrofitModule(retrofit: RetrofitModule):Builder


//        @BindsInstance
//        @Named("roomParkApi")
//        fun retrofit(
//            retorfitModule: RetrofitModule
//        ): DaggerDataComponent.Builder

//
//        fun  build(): AppComponent



    }


//    fun cache(): ICachedStore
//    fun context(): Context
//    fun db(): IDb
//    fun api(): IApi
//    fun roomApi(): IRoomParkApi
//    fun fileModule(): FilesModule
////    fun appLifeCycle(): AppLifecycleListener
//    fun networkMonitor(): INetworkMonitor
//    fun versionMonitor(): IAppVersionControl
//    fun versionNotifier(): IAppVersionNotifier
//
//    fun estateRepo() : IEstateRepository
//    fun tourRepo() : ITourRepository
//    fun userRepo() : IUserRepository

}