package com.biganto.visual.roompark.presentation.screen.article

import com.biganto.visual.roompark.conductor.BigantoBaseViewState
import com.biganto.visual.roompark.domain.model.ArticleModel

/**
 * Created by Vladislav Bogdashkin on 30.09.2019.
 */


sealed class ArticleScreenViewState : BigantoBaseViewState() {
    class Idle : ArticleScreenViewState()
    class ArticleLoaded(val item: ArticleModel) : ArticleScreenViewState()
}